
package com.smartgwt.client.docs;

/**
 * <h3>Drag and Drop</h3>
 * Dragging objects and dropping them onto other objects
 * @see com.smartgwt.client.types.ReorderPosition
 * @see com.smartgwt.client.types.DragAppearance
 * @see com.smartgwt.client.types.DragIntersectStyle
 * @see com.smartgwt.client.types.ProportionalResizeMode
 * @see com.smartgwt.client.types.DragMaskType
 * @see com.smartgwt.client.types.DragDataAction
 * @see com.smartgwt.client.util.EventHandler#setDragTrackerImage
 * @see com.smartgwt.client.util.EventHandler#setDragOffset
 * @see com.smartgwt.client.util.EventHandler#setDragTracker
 * @see com.smartgwt.client.util.EventHandler#getDragRect
 * @see com.smartgwt.client.widgets.Canvas#getEventEdge
 * @see com.smartgwt.client.widgets.grid.ListGrid#transferSelectedData
 * @see com.smartgwt.client.widgets.tile.TileGrid#transferSelectedData
 * @see com.smartgwt.client.widgets.grid.ColumnTree#folderDrop
 * @see com.smartgwt.client.widgets.grid.ColumnTree#transferNodes
 * @see com.smartgwt.client.widgets.layout.PortalLayout#setPortletDropTypes
 * @see com.smartgwt.client.widgets.layout.PortalLayout#willAcceptPortletDrop
 * @see com.smartgwt.client.widgets.Canvas#setDragTracker
 * @see com.smartgwt.client.widgets.Canvas#shouldDragScroll
 * @see com.smartgwt.client.widgets.Canvas#willAcceptDrop
 * @see com.smartgwt.client.widgets.Canvas#getHSnapPosition
 * @see com.smartgwt.client.widgets.grid.ListGrid#getCanDropInEmptyArea
 * @see com.smartgwt.client.widgets.tree.TreeGrid#getManyItemsImage
 * @see com.smartgwt.client.widgets.tile.TileGrid#getTileDragAppearance
 * @see com.smartgwt.client.widgets.grid.ColumnTree#getCanDragRecordsOut
 * @see com.smartgwt.client.widgets.layout.Layout#getCanDropComponents
 * @see com.smartgwt.client.widgets.layout.Layout#getDropLineThickness
 * @see com.smartgwt.client.widgets.layout.Layout#getShowDropLines
 * @see com.smartgwt.client.widgets.layout.Layout#getShowDragPlaceHolder
 * @see com.smartgwt.client.widgets.layout.Layout#getPlaceHolderProperties
 * @see com.smartgwt.client.widgets.layout.Layout#getPlaceHolderDefaults
 * @see com.smartgwt.client.widgets.layout.SectionStack#getCanDropComponents
 * @see com.smartgwt.client.widgets.Window#getKeepInParentRect
 * @see com.smartgwt.client.widgets.Window#getResizeFrom
 * @see com.smartgwt.client.widgets.layout.Portlet#getDragType
 * @see com.smartgwt.client.widgets.layout.PortalLayout#getPortletDropTypes
 * @see com.smartgwt.client.widgets.layout.PortalLayout#getDropTypes
 * @see com.smartgwt.client.widgets.tab.TabSet#getCanReorderTabs
 * @see com.smartgwt.client.widgets.drawing.DrawItem#getDragStartDistance
 * @see com.smartgwt.client.widgets.Canvas#getUseNativeDrag
 * @see com.smartgwt.client.widgets.Canvas#getCanDrag
 * @see com.smartgwt.client.widgets.Canvas#getDragStartDistance
 * @see com.smartgwt.client.widgets.Canvas#getDragIntersectStyle
 * @see com.smartgwt.client.widgets.Canvas#getCanDragReposition
 * @see com.smartgwt.client.widgets.Canvas#getDragRepositionCursor
 * @see com.smartgwt.client.widgets.Canvas#getCanDragResize
 * @see com.smartgwt.client.widgets.Canvas#getProportionalResizing
 * @see com.smartgwt.client.widgets.Canvas#getProportionalResizeModifiers
 * @see com.smartgwt.client.widgets.Canvas#getResizeFrom
 * @see com.smartgwt.client.widgets.Canvas#getUseDragMask
 * @see com.smartgwt.client.widgets.Canvas#getDragMaskType
 * @see com.smartgwt.client.widgets.Canvas#getEdgeMarginSize
 * @see com.smartgwt.client.widgets.Canvas#getMinNonEdgeSize
 * @see com.smartgwt.client.widgets.Canvas#getEdgeCursorMap
 * @see com.smartgwt.client.widgets.Canvas#getKeepInParentRect
 * @see com.smartgwt.client.widgets.Canvas#getDragAppearance
 * @see com.smartgwt.client.widgets.Canvas#getDragResizeAppearance
 * @see com.smartgwt.client.widgets.Canvas#getDragRepositionAppearance
 * @see com.smartgwt.client.widgets.Canvas#getDragType
 * @see com.smartgwt.client.widgets.Canvas#getDropTypes
 * @see com.smartgwt.client.widgets.Canvas#getDragTarget
 * @see com.smartgwt.client.widgets.Canvas#getDropTarget
 * @see com.smartgwt.client.widgets.Canvas#getShowDragShadow
 * @see com.smartgwt.client.widgets.Canvas#getDragOpacity
 * @see com.smartgwt.client.widgets.Canvas#getCanDrop
 * @see com.smartgwt.client.widgets.Canvas#getCanAcceptDrop
 */
public interface Dragdrop {
}
